package com.practise.mdb;

import java.util.Date;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.jms.TextMessage;

import org.jboss.ejb3.annotation.ResourceAdapter;

/**
 * Message-Driven Bean implementation class for: QueueListenerMDB
 */
@MessageDriven(
		activationConfig = { @ActivationConfigProperty(
				propertyName = "destinationType", propertyValue = "javax.jms.TOPIC"),
				@ActivationConfigProperty(propertyName="destination",propertyValue="/topic/mailTopic"),
				
		})
@ResourceAdapter("hornetq-ra.rar")
public class QueueListenerMDB implements MessageListener {

    /**
     * Default constructor. 
     */
    public QueueListenerMDB() {
        // TODO Auto-generated constructor stub
    }
	
	/**
     * @see MessageListener#onMessage(Message)
     */
    public void onMessage(Message message) {
    	 try {
    		 System.out.println(message);
             if (message instanceof TextMessage) {
                 System.out.println("Queue: I received a TextMessage at "
                                 + new Date());
                 TextMessage msg = (TextMessage) message;
                 System.out.println("Message is : " + msg.getText());
             } else if (message instanceof ObjectMessage) {
                 System.out.println("Queue: I received an ObjectMessage at "
                                 + new Date());
                 ObjectMessage msg = (ObjectMessage) message;
                 Employee employee = (Employee) msg.getObject();
                 System.out.println("Employee Details: ");
                 System.out.println(employee.getId());
                 System.out.println(employee.getName());
                 System.out.println(employee.getDesignation());
                 System.out.println(employee.getSalary());
             } else {
                 System.out.println("Not a valid message for this Queue MDB");
             }
  
         } catch (JMSException e) {
             e.printStackTrace();
         }
        
    }

}
